<!DOCTYPE HTML>
<html lang="en">
	<head>
		<title>YOLO: Real-Time Object Detection</title>
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <meta name="author" content="Joseph Redmon">
                <meta name="msvalidate.01" content="305CD82AE65FC4C9597F80416C1271B7" />
		<link rel='stylesheet' media='screen' href='/static/css_v2.3/base.css' />
		<link rel='stylesheet' media='screen' href='/static/css_v2.3/darknet.css' />
        <link rel='stylesheet' media='screen' href='/static/css_v2.3/index.css' />
		<link rel='stylesheet' media='screen' href='/static/css_v2.3/papers.css' />
		<link rel='stylesheet' media='screen' href='/static/css_v2.3/projects.css' />
		<link rel='stylesheet' media='screen' href='/static/css_v2.3/coqindex.css' />

        <link href='//fonts.googleapis.com/css?family=Roboto+Slab:400,400italic' rel='stylesheet' type='text/css'>
        <link href='//fonts.googleapis.com/css?family=Ubuntu+Mono' rel='stylesheet' type='text/css'>
        <link href='//fonts.googleapis.com/css?family=Roboto:300,300italic,100italic,100,500' rel='stylesheet' type='text/css'>
		
		<link rel='icon' type='image/png' href='/static/icon.png' />
		
		
        <meta name="description" content="You only look once (YOLO) is a state-of-the-art, real-time object detection system.">
	
		<script type="text/javascript">

		  var _gaq = _gaq || [];
		  _gaq.push(['_setAccount', 'UA-37236849-1']);
		  _gaq.push(['_trackPageview']);

		  (function() {
			var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
			ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
			var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
		  })();

		</script>
	</head>

	<body>
		<div class=top>
			<ul class="nav">
				<a href="/"><li>home</li></a>
				<a href="/darknet/"><li class=relative><img id=dncircle src="/static/img/darknet_notext.png"></img>darknet</li></a>
				<a href="/coq-tactics/"><li class=relative><img id=dncircle src="/static/img/coq.png"></img>coq tactics</li></a>
				<a href="/publications/"><li>publications</li></a>
				<a href="/projects/"><li>projects</li></a>
				
				<a href="/resume/"><li>résumé</li></a>
			</ul>
			<div class=break></div>
			
			<div class=break></div>
		</div>
		
    <div class="main markdown">
        <p id=dnlogo>
            
                <img  src="/media/image/yologo_2.png"></img>
            
        </p>
        <h1>YOLO: Real-Time Object Detection</h1>
        <p>You only look once (YOLO) is a state-of-the-art, real-time object detection system. On a Pascal Titan X it processes images at 30 FPS and has a mAP of 57.9% on COCO test-dev.</p>
<iframe width="100%" height="415" src="https://www.youtube.com/embed/MPU2HistivI" frameborder="0" allow="autoplay; encrypted-media" allowfullscreen></iframe>

<style>
td:first-child {text-align:left;}
td {text-align:right; padding:0em .5em;}
th {padding:0em .5em;}
table {
margin:0em auto 3em; font-size:1em;
}
@media (max-width: 640px) {
  table {
    font-size: .75em;
  }
.model {
  font-size: .5em;
}
}
</style>

<h2>Comparison to Other Detectors</h2>
<p>YOLOv3 is extremely fast and accurate. In mAP measured at .5 IOU YOLOv3 is on par with Focal Loss but about 4x faster. Moreover, you can easily tradeoff between speed and accuracy simply by changing the size of the model, no retraining required!</p>
<p><img alt="" src="/media/image/map50blue.png" /></p>
<h2>Performance on the COCO Dataset</h2>
<table>
  <tr>
    <th style="text-align:left;">Model</th>
    <th style="text-align:right;">Train</th> 
    <th style="text-align:right;">Test</th>
    <th style="text-align:right;">mAP</th>
    <th style="text-align:right; ">FLOPS</th>
    <th style="text-align:right; ">FPS</th>
    <th style="text-align:right; ">Cfg</th>
    <th style="text-align:right; ">Weights</th>
  </tr>


 <tr>
<td>SSD300</td>
<td>COCO trainval</td> 
<td>test-dev</td>
<td>41.2</td>
<td>-</td>
<td>46</td>
<td colspan = "2"><a href =https://arxiv.org/abs/1512.02325 >link</a></td>
</tr>
 <tr>
<td>SSD500</td>
<td>COCO trainval</td> 
<td>test-dev</td>
<td>46.5</td>
<td>-</td>
<td>19</td>
<td colspan="2"><a href =https://arxiv.org/abs/1512.02325 >link</a></td>
</tr>

<tr>
<td>YOLOv2 608x608</td>
<td>COCO trainval</td> 
<td>test-dev</td>
<td>48.1</td>
<td>62.94 Bn</td>
<td>40</td>
<td><a href=https://github.com/pjreddie/darknet/blob/master/cfg/yolov2.cfg>cfg</a></td>
<td><a href=https://pjreddie.com/media/files/yolov2.weights>weights</a></td>
</tr>
<tr>
<td>Tiny YOLO</td>
<td>COCO trainval</td> 
<td>test-dev</td>
<td>23.7</td>
<td>5.41 Bn</td>
<td>244</td>
<td><a href=https://github.com/pjreddie/darknet/blob/master/cfg/yolov2-tiny.cfg>cfg</a></td>
<td><a href=https://pjreddie.com/media/files/yolov2-tiny.weights>weights</a></td>
</tr>

<tr>
          <td colspan="8"><hr/></td>
</tr>


<tr>
<td>SSD321</td>
<td>COCO trainval</td> 
<td>test-dev</td>
<td>45.4</td>
<td>-</td>
<td>16</td>
<td colspan = "2"><a href =https://arxiv.org/abs/1701.06659 >link</a></td>
</tr>
<tr>
<td>DSSD321</td>
<td>COCO trainval</td> 
<td>test-dev</td>
<td>46.1</td>
<td>-</td>
<td>12</td>
<td colspan = "2"><a href =https://arxiv.org/abs/1701.06659 >link</a></td>
</tr>
<tr>
<td>R-FCN</td>
<td>COCO trainval</td> 
<td>test-dev</td>
<td>51.9</td>
<td>-</td>
<td>12</td>
<td colspan = "2"><a href =https://arxiv.org/abs/1605.06409 >link</a></td>
</tr>
<tr>
<td>SSD513</td>
<td>COCO trainval</td> 
<td>test-dev</td>
<td>50.4</td>
<td>-</td>
<td>8</td>
<td colspan = "2"><a href =https://arxiv.org/abs/1701.06659 >link</a></td>
</tr>
<tr>
<td>DSSD513</td>
<td>COCO trainval</td> 
<td>test-dev</td>
<td>53.3</td>
<td>-</td>
<td>6</td>
<td colspan = "2"><a href =https://arxiv.org/abs/1701.06659 >link</a></td>
</tr>
<tr>
<td>FPN FRCN</td>
<td>COCO trainval</td> 
<td>test-dev</td>
<td>59.1</td>
<td>-</td>
<td>6</td>
<td colspan = "2"><a href =https://arxiv.org/abs/1612.03144 >link</a></td>
</tr>
<tr>
<td>Retinanet-50-500</td>
<td>COCO trainval</td> 
<td>test-dev</td>
<td>50.9</td>
<td>-</td>
<td>14</td>
<td colspan = "2"><a https://arxiv.org/abs/1708.02002 >link</a></td>
</tr>
<tr>
<td>Retinanet-101-500</td>
<td>COCO trainval</td> 
<td>test-dev</td>
<td>53.1</td>
<td>-</td>
<td>11</td>
<td colspan = "2"><a https://arxiv.org/abs/1708.02002 >link</a></td>
</tr>
<tr>
<td>Retinanet-101-800</td>
<td>COCO trainval</td> 
<td>test-dev</td>
<td>57.5</td>
<td>-</td>
<td>5</td>
<td colspan = "2"><a https://arxiv.org/abs/1708.02002 >link</a></td>
</tr>
<tr>
<td>YOLOv3-320</td>
<td>COCO trainval</td> 
<td>test-dev</td>
<td>51.5</td>
<td>38.97 Bn</td>
<td>45</td>
<td><a href=https://github.com/pjreddie/darknet/blob/master/cfg/yolov3.cfg>cfg</a></td>
<td><a href=https://pjreddie.com/media/files/yolov3.weights>weights</a></td>
</tr>
<tr>
<td>YOLOv3-416</td>
<td>COCO trainval</td> 
<td>test-dev</td>
<td>55.3</td>
<td>65.86 Bn</td>
<td>35</td>
<td><a href=https://github.com/pjreddie/darknet/blob/master/cfg/yolov3.cfg>cfg</a></td>
<td><a href=https://pjreddie.com/media/files/yolov3.weights>weights</a></td>
</tr>
<tr>
<td>YOLOv3-608</td>
<td>COCO trainval</td> 
<td>test-dev</td>
<td>57.9</td>
<td>140.69 Bn</td>
<td>20</td>
<td><a href=https://github.com/pjreddie/darknet/blob/master/cfg/yolov3.cfg>cfg</a></td>
<td><a href=https://pjreddie.com/media/files/yolov3.weights>weights</a></td>
</tr>
<tr>
<td>YOLOv3-tiny</td>
<td>COCO trainval</td> 
<td>test-dev</td>
<td>33.1</td>
<td>5.56 Bn</td>
<td>220</td>
<td><a href=https://github.com/pjreddie/darknet/blob/master/cfg/yolov3-tiny.cfg>cfg</a></td>
<td><a href=https://pjreddie.com/media/files/yolov3-tiny.weights>weights</a></td>
</tr>
<tr>
<td>YOLOv3-spp</td>
<td>COCO trainval</td> 
<td>test-dev</td>
<td>60.6</td>
<td>141.45 Bn</td>
<td>20</td>
<td><a href=https://github.com/pjreddie/darknet/blob/master/cfg/yolov3-spp.cfg>cfg</a></td>
<td><a href=https://pjreddie.com/media/files/yolov3-spp.weights>weights</a></td>
</tr>

</table>

<h2>How It Works</h2>
<p>Prior detection systems repurpose classifiers or localizers to perform detection. They apply the model to an image at multiple locations and scales. High scoring regions of the image are considered detections.</p>
<p>We use a totally different approach. We apply a single neural network to the full image. This network divides the image into regions and predicts bounding boxes and probabilities for each region. These bounding boxes are weighted by the predicted probabilities.</p>
<p><img alt="" src="/media/image/sayit.jpg" /></p>
<p>Our model has several advantages over classifier-based systems. It looks at the whole image at test time so its predictions are informed by global context in the image. It also makes predictions with a single network evaluation unlike systems like <a href="https://github.com/rbgirshick/rcnn">R-CNN</a> which require thousands for a single image. This makes it extremely fast, more than 1000x faster than R-CNN and 100x faster than <a href="https://github.com/rbgirshick/fast-rcnn">Fast R-CNN</a>. See our <a href="https://pjreddie.com/media/files/papers/YOLOv3.pdf">paper</a> for more details on the full system.</p>
<h3>What's New in Version 3?</h3>
<p>YOLOv3 uses a few tricks to improve training and increase performance, including: multi-scale predictions, a better backbone classifier, and more. The full details are in our <a href="https://pjreddie.com/media/files/papers/YOLOv3.pdf">paper</a>!</p>
<h2>Detection Using A Pre-Trained Model</h2>
<p>This post will guide you through detecting objects with the YOLO system using a pre-trained model. If you don't already have Darknet installed, you should <a href="https://pjreddie.com/darknet/install/">do that first</a>. Or instead of reading all that just run:</p>
<pre><code>git clone https://github.com/pjreddie/darknet
cd darknet
make
</code></pre>
<p>Easy!</p>
<p>You already have the config file for YOLO in the <code>cfg/</code> subdirectory. You will have to download the pre-trained weight file <a href="https://pjreddie.com/media/files/yolov3.weights">here (237 MB)</a>. Or just run this:</p>
<pre><code>wget https://pjreddie.com/media/files/yolov3.weights
</code></pre>
<p>Then run the detector!</p>
<pre><code>./darknet detect cfg/yolov3.cfg yolov3.weights data/dog.jpg
</code></pre>
<p>You will see some output like this:</p>
<pre><code>layer     filters    size              input                output
    0 conv     32  3 x 3 / 1   416 x 416 x   3   -&gt;   416 x 416 x  32  0.299 BFLOPs
    1 conv     64  3 x 3 / 2   416 x 416 x  32   -&gt;   208 x 208 x  64  1.595 BFLOPs
    .......
  105 conv    255  1 x 1 / 1    52 x  52 x 256   -&gt;    52 x  52 x 255  0.353 BFLOPs
  106 detection
truth_thresh: Using default '1.000000'
Loading weights from yolov3.weights...Done!
data/dog.jpg: Predicted in 0.029329 seconds.
dog: 99%
truck: 93%
bicycle: 99%
</code></pre>
<p><img alt="" src="/media/image/Screen_Shot_2018-03-24_at_10.48.42_PM.png" /></p>
<p>Darknet prints out the objects it detected, its confidence, and how long it took to find them. We didn't compile Darknet with <code>OpenCV</code> so it can't display the detections directly. Instead, it saves them in <code>predictions.png</code>. You can open it to see the detected objects. Since we are using Darknet on the CPU it takes around 6-12 seconds per image. If we use the GPU version it would be much faster.</p>
<p>I've included some example images to try in case you need inspiration. Try <code>data/eagle.jpg</code>, <code>data/dog.jpg</code>, <code>data/person.jpg</code>, or <code>data/horses.jpg</code>!</p>
<p>The <code>detect</code> command is shorthand for a more general version of the command. It is equivalent to the command:</p>
<pre><code>./darknet detector test cfg/coco.data cfg/yolov3.cfg yolov3.weights data/dog.jpg
</code></pre>
<p>You don't need to know this if all you want to do is run detection on one image but it's useful to know if you want to do other things like run on a webcam (which you will see <a href="#demo">later on</a>).</p>
<h3>Multiple Images</h3>
<p>Instead of supplying an image on the command line, you can leave it blank to try multiple images in a row. Instead you will see a prompt when the config and weights are done loading:</p>
<pre><code>./darknet detect cfg/yolov3.cfg yolov3.weights
layer     filters    size              input                output
    0 conv     32  3 x 3 / 1   416 x 416 x   3   -&gt;   416 x 416 x  32  0.299 BFLOPs
    1 conv     64  3 x 3 / 2   416 x 416 x  32   -&gt;   208 x 208 x  64  1.595 BFLOPs
    .......
  104 conv    256  3 x 3 / 1    52 x  52 x 128   -&gt;    52 x  52 x 256  1.595 BFLOPs
  105 conv    255  1 x 1 / 1    52 x  52 x 256   -&gt;    52 x  52 x 255  0.353 BFLOPs
  106 detection
Loading weights from yolov3.weights...Done!
Enter Image Path:
</code></pre>
<p>Enter an image path like <code>data/horses.jpg</code> to have it predict boxes for that image.</p>
<p><img alt="" src="/media/image/Screen_Shot_2018-03-24_at_10.53.04_PM.png" /></p>
<p>Once it is done it will prompt you for more paths to try different images. Use <code>Ctrl-C</code> to exit the program once you are done.</p>
<h3>Changing The Detection Threshold</h3>
<p>By default, YOLO only displays objects detected with a confidence of .25 or higher. You can change this by passing the <code>-thresh &lt;val&gt;</code> flag to the <code>yolo</code> command. For example, to display all detection you can set the threshold to 0:</p>
<pre><code>./darknet detect cfg/yolov3.cfg yolov3.weights data/dog.jpg -thresh 0
</code></pre>
<p>Which produces:</p>
<p>![][all]</p>
<p>So that's obviously not super useful but you can set it to different values to control what gets thresholded by the model.</p>
<h3>Tiny YOLOv3</h3>
<p>We have a very small model as well for constrained environments, <code>yolov3-tiny</code>. To use this model, first download the weights:</p>
<pre><code>wget https://pjreddie.com/media/files/yolov3-tiny.weights
</code></pre>
<p>Then run the detector with the tiny config file and weights:</p>
<pre><code>./darknet detect cfg/yolov3-tiny.cfg yolov3-tiny.weights data/dog.jpg
</code></pre>
<h2><a name=demo></a>Real-Time Detection on a Webcam</h2>
<p>Running YOLO on test data isn't very interesting if you can't see the result. Instead of running it on a bunch of images let's run it on the input from a webcam!</p>
<p>To run this demo you will need to compile <a href="https://pjreddie.com/darknet/install/#cuda">Darknet with CUDA and OpenCV</a>. Then run the command:</p>
<pre><code>./darknet detector demo cfg/coco.data cfg/yolov3.cfg yolov3.weights
</code></pre>
<p>YOLO will display the current FPS and predicted classes as well as the image with bounding boxes drawn on top of it.</p>
<p>You will need a webcam connected to the computer that OpenCV can connect to or it won't work. If you have multiple webcams connected and want to select which one to use you can pass the flag <code>-c &lt;num&gt;</code> to pick (OpenCV uses webcam <code>0</code> by default).</p>
<p>You can also run it on a video file if OpenCV can read the video:</p>
<pre><code>./darknet detector demo cfg/coco.data cfg/yolov3.cfg yolov3.weights &lt;video file&gt;
</code></pre>
<p>That's how we made the YouTube video above.</p>
<h2><a name=train-voc></a>Training YOLO on VOC</h2>
<p>You can train YOLO from scratch if you want to play with different training regimes, hyper-parameters, or datasets. Here's how to get it working on the Pascal VOC dataset.</p>
<h3>Get The Pascal VOC Data</h3>
<p>To train YOLO you will need all of the VOC data from 2007 to 2012. You can find links to the data <a href="https://pjreddie.com/projects/pascal-voc-dataset-mirror/">here</a>. To get all the data, make a directory to store it all and from that directory run:</p>
<pre><code>wget https://pjreddie.com/media/files/VOCtrainval_11-May-2012.tar
wget https://pjreddie.com/media/files/VOCtrainval_06-Nov-2007.tar
wget https://pjreddie.com/media/files/VOCtest_06-Nov-2007.tar
tar xf VOCtrainval_11-May-2012.tar
tar xf VOCtrainval_06-Nov-2007.tar
tar xf VOCtest_06-Nov-2007.tar
</code></pre>
<p>There will now be a <code>VOCdevkit/</code> subdirectory with all the VOC training data in it. </p>
<h3>Generate Labels for VOC</h3>
<p>Now we need to generate the label files that Darknet uses. Darknet wants a <code>.txt</code> file for each image with a line for each ground truth object in the image that looks like:</p>
<pre><code>&lt;object-class&gt; &lt;x&gt; &lt;y&gt; &lt;width&gt; &lt;height&gt;
</code></pre>
<p>Where <code>x</code>, <code>y</code>, <code>width</code>, and <code>height</code> are relative to the image's width and height. To generate these file we will run the <code>voc_label.py</code> script in Darknet's <code>scripts/</code> directory. Let's just download it again because we are lazy.</p>
<pre><code>wget https://pjreddie.com/media/files/voc_label.py
python voc_label.py
</code></pre>
<p>After a few minutes, this script will generate all of the requisite files. Mostly it generates a lot of label files in <code>VOCdevkit/VOC2007/labels/</code> and <code>VOCdevkit/VOC2012/labels/</code>. In your directory you should see:</p>
<pre><code>ls
2007_test.txt   VOCdevkit
2007_train.txt  voc_label.py
2007_val.txt    VOCtest_06-Nov-2007.tar
2012_train.txt  VOCtrainval_06-Nov-2007.tar
2012_val.txt    VOCtrainval_11-May-2012.tar
</code></pre>
<p>The text files like <code>2007_train.txt</code> list the image files for that year and image set. Darknet needs one text file with all of the images you want to train on. In this example, let's train with everything except the 2007 test set so that we can test our model. Run:</p>
<pre><code>cat 2007_train.txt 2007_val.txt 2012_*.txt &gt; train.txt
</code></pre>
<p>Now we have all the 2007 trainval and the 2012 trainval set in one big list. That's all we have to do for data setup!</p>
<h3>Modify Cfg for Pascal Data</h3>
<p>Now go to your Darknet directory. We have to change the <code>cfg/voc.data</code> config file to point to your data:</p>
<pre><code>  1 classes= 20
  2 train  = &lt;path-to-voc&gt;/train.txt
  3 valid  = &lt;path-to-voc&gt;2007_test.txt
  4 names = data/voc.names
  5 backup = backup
</code></pre>
<p>You should replace <code>&lt;path-to-voc&gt;</code> with the directory where you put the VOC data.</p>
<h3>Download Pretrained Convolutional Weights</h3>
<p>For training we use convolutional weights that are pre-trained on Imagenet. We use weights from the <a href="https://pjreddie.com/darknet/imagenet/#darknet53">darknet53</a> model. You can just download the weights for the convolutional layers <a href="https://pjreddie.com/media/files/darknet53.conv.74">here (76 MB)</a>.</p>
<pre><code>wget https://pjreddie.com/media/files/darknet53.conv.74
</code></pre>
<h3>Train The Model</h3>
<p>Now we can train! Run the command:</p>
<pre><code>./darknet detector train cfg/voc.data cfg/yolov3-voc.cfg darknet53.conv.74
</code></pre>
<h2><a name=train-coco></a>Training YOLO on COCO</h2>
<p>You can train YOLO from scratch if you want to play with different training regimes, hyper-parameters, or datasets. Here's how to get it working on the <a href="http://mscoco.org/dataset/#overview">COCO dataset</a>.</p>
<h3>Get The COCO Data</h3>
<p>To train YOLO you will need all of the COCO data and labels. The script <code>scripts/get_coco_dataset.sh</code> will do this for you. Figure out where you want to put the COCO data and download it, for example:</p>
<pre><code>cp scripts/get_coco_dataset.sh data
cd data
bash get_coco_dataset.sh
</code></pre>
<p>Now you should have all the data and the labels generated for Darknet.</p>
<h3>Modify cfg for COCO</h3>
<p>Now go to your Darknet directory. We have to change the <code>cfg/coco.data</code> config file to point to your data:</p>
<pre><code>  1 classes= 80
  2 train  = &lt;path-to-coco&gt;/trainvalno5k.txt
  3 valid  = &lt;path-to-coco&gt;/5k.txt
  4 names = data/coco.names
  5 backup = backup
</code></pre>
<p>You should replace <code>&lt;path-to-coco&gt;</code> with the directory where you put the COCO data.</p>
<p>You should also modify your model cfg for training instead of testing. <code>cfg/yolo.cfg</code> should look like this:</p>
<pre><code>[net]
# Testing
# batch=1
# subdivisions=1
# Training
batch=64
subdivisions=8
....
</code></pre>
<h3>Train The Model</h3>
<p>Now we can train! Run the command:</p>
<pre><code>./darknet detector train cfg/coco.data cfg/yolov3.cfg darknet53.conv.74
</code></pre>
<p>If you want to use multiple gpus run:</p>
<pre><code>./darknet detector train cfg/coco.data cfg/yolov3.cfg darknet53.conv.74 -gpus 0,1,2,3
</code></pre>
<p>If you want to stop and restart training from a checkpoint:</p>
<pre><code>./darknet detector train cfg/coco.data cfg/yolov3.cfg backup/yolov3.backup -gpus 0,1,2,3
</code></pre>
<h2><a name=openimages></a> YOLOv3 on the Open Images dataset</h2>
<pre><code>wget https://pjreddie.com/media/files/yolov3-openimages.weights

./darknet detector test cfg/openimages.data cfg/yolov3-openimages.cfg yolov3-openimages.weights
</code></pre>
<h2>What Happened to the Old YOLO Site?</h2>
<p>If you are using YOLO version 2 you can still find the site here: <a href="https://pjreddie.com/darknet/yolov2/">https://pjreddie.com/darknet/yolov2/</a></p>
<h2>Cite</h2>
<p>If you use YOLOv3 in your work please cite our paper!</p>
<pre><code>@article{yolov3,
  title={YOLOv3: An Incremental Improvement},
  author={Redmon, Joseph and Farhadi, Ali},
  journal = {arXiv},
  year={2018}
}
</code></pre>
    </div>
    
        

	</body>
</html>
